#ifndef _HASH_INCLUDE_H
#define _HASH_INCLUDE_H

#include <stdlib.h>


#define HASH_DEFAULT_SIZE 1337


typedef unsigned long hash_key_t;


typedef struct _hash_t hash_t;
struct _hash_t
{
    const void     *data;
    size_t          data_sz;
    struct _hash_t *bucket;
};


extern hash_t *hash_create(int n_keys);
extern hash_key_t hash_default_hash(const char *data, size_t data_sz);
extern void hash_add(hash_t *hash, const void *data, size_t data_sz, hash_key_t key);
extern void hash_print_entries_as_strings(const hash_t *hash, int n_keys);
extern int hash_matches(const hash_t *hash, void *data, size_t data_sz);


#endif /* _HASH_INCLUDE_H */
