#ifndef _MAIN_H_INCLUDE
#define _MAIN_H_INCLUDE

#include "hash.h"


#define BLOCK_SIZE       1024
#define RSS_URL_LENGTH   512
#define RSS_TITLE_LENGTH 256
#define RSS_MATCH_LENGTH RSS_TITLE_LENGTH
#define VERSION "0.1"


#define ERR_NULL(_expr) if (!(_expr)){ perror(#_expr); exit(-1); }
#define ERR_NEG(_expr) if ((_expr) < 0){ perror(#_expr); exit(-1); }


#define MIN(_a, _b) (((_a) < (_b)) ? (_a) : (_b))


typedef struct _rss_t rss_t;
struct _rss_t
{
    char title[RSS_TITLE_LENGTH];
    char matched_words[RSS_MATCH_LENGTH];
    char url[RSS_URL_LENGTH];

    int n_words;
    int n_matches;
};


extern rss_t *utils_get_rss(const char *url, int *n_entries);
extern hash_t *utils_get_lyrics(const char *fname, int *n_keys);


#endif /* _MAIN_H_INCLUDE */
